using UnityEngine;
using System.Collections;

public class FPAudioController : MonoBehaviour {
	float PlayVolume;

	float TimeNextAction;
	float GroundSpeed;
	int StepNr;
	int StepNrMax;
	float StepRate;
	
	Vector3 TempPosition;
	Vector3 OldPosition;
	bool OldPositionTaken;
	
	bool IsJumping;

	public AudioClip Clip01_Step00;
	public AudioClip Clip02_Step01;
	public AudioClip Clip03_Step02;
	public AudioClip Clip04_Step03;
	public AudioClip Clip05_Step04;
	public AudioClip Clip06_Step05;
	
	// Use this for initialization
	void Awake () {		
		StepNrMax = 3;
		StepNr = 0;
		
		StepRate = 0.4f;
		
		TimeNextAction = Time.time + StepRate;
		
		TempPosition = transform.position;
		OldPosition = TempPosition;
		
		IsJumping = false;
	}
	
	// Update is called once per frame
	void Update () {

		TempPosition = transform.position - OldPosition;
		OldPosition = transform.position;
		
		if (    TempPosition.magnitude > 0.01f
			 && TimeNextAction <= Time.time     ){
			
			PlayVolume = 0.2f;
			audio.volume = PlayVolume;
				
			if (StepNr == 0){
				audio.PlayOneShot (Clip01_Step00);					
			}
			
			if (StepNr == 1){
				audio.PlayOneShot (Clip02_Step01);					
			}

			if (StepNr == 2){
				audio.PlayOneShot (Clip03_Step02);					
			}
			
			if (StepNr == 3){
				audio.PlayOneShot (Clip04_Step03);								
			}
			
			if (StepNr == 4){
				audio.PlayOneShot (Clip05_Step04);					
			}
			
			if (StepNr == 5){
				audio.PlayOneShot (Clip06_Step05);					
			}
			
			if (StepNr < StepNrMax){
				StepNr++;
			}
			else{
				StepNr = 0;
			}
			
			TimeNextAction = Time.time + StepRate;
			IsJumping = false;
				
		}
		
		if (    !IsJumping
			 && Input.GetKey(KeyCode.Space) ){
			IsJumping = true;
			TimeNextAction = TimeNextAction + 0.5f;
		}
  
	}
}
