using UnityEngine;
using System.Collections;

public class GameRules : MonoBehaviour {
	GameConstants MyGameConstants;
	float NextTimeAction;

	public GUIStyle CustomGUIStyle;
	public GUIStyle BigCustomGUIStyle;
    Rect GuiRect;

	public int ActEnemyHealth;
	public int ActEnemyPower;

	bool HasEnded;

	public int GameState;
	public const int MaxGameState = 100;

	public string[] StepTitle;
	public string[] StepText;
	public string[] StepOption01;
	public string[] StepOption02;
	public string[] StepOption03;
	public string[] StepOption04;

	public Transform[] Steps;

	public AudioClip TheSound01;
	
	bool DropStep;

	// Use this for initialization
	void Awake () {
		MyGameConstants = FindObjectOfType(typeof(GameConstants)) as GameConstants;
		NextTimeAction = Time.time + 0f;
		MyGameConstants.LevelUpAmount = 1;
		MyGameConstants.DoingReset = false;
		HasEnded = false;

		GameState = 0;

		StepTitle = new string[MaxGameState];
		StepText = new string[MaxGameState];
		StepOption01 = new string[MaxGameState];
		StepOption02 = new string[MaxGameState];
		StepOption03 = new string[MaxGameState];
		StepOption04 = new string[MaxGameState];

		StepTitle[0] = "The Itch";
		StepText[0] = "It's late in the evening, you are just about to go to bed. You feel a strange, itching sensation in your left arm. " +
			"It seems like there is something moving under your skin. You have to scratch it..."  ;
		StepOption01[0] = "";
		StepOption02[0] = "A - Yes I do.";
		StepOption03[0] = "D - No, I shouldn't do that!";
		StepOption04[0] = "";

		StepTitle[1] = "Good Ending 1";
		StepText[1] = "Yes, it's the best to just ignore a little itch and by no means ever scratch it! It just went away within minutes, " +
			"I guess there was nothing there to begin with. Have a nice day!"  ;
		StepOption01[1] = "R - Restart game";
		StepOption02[1] = "";
		StepOption03[1] = "";
		StepOption04[1] = "";

		StepTitle[2] = "Alien Abduction";
		StepText[2] = "You ignore your arm and fall into a deep sleep. You dream of bright lights coming from your window, taking " +
			"you up and away with them. Then, a brightly lit room, a cold examination table, gray men, probes, pain... You wake up " +
				"in the morning with a strange taste in your mouth, and a bad pain in your arm. There is a little wound there. Did you scratch it "+
				"in your sleep ?";
		StepOption01[2] = "R - Restart game";
		StepOption02[2] = "";
		StepOption03[2] = "";
		StepOption04[2] = "";

		StepTitle[3] = "The parasite";
		StepText[3] = "The itching went away, but now you are pretty sure there is something moving under your skin. It's moving, growing there, " +
			"it's probably eating your flesh, but you feel no pain. It's more like it's your baby you are carrying around in your arm. "+
				"It turned black and blue, and feels pretty numb by now. You decided to stay at home, and wait for your baby to come out." +
				"I wonder what it looks like...";
		StepOption01[3] = "R - Restart game";
		StepOption02[3] = "";
		StepOption03[3] = "";
		StepOption04[3] = "";

		StepTitle[4] = "The programmer";
		StepText[4] = "Hey, it's just me, saying HI... Please ignore this ending! :)";
		StepOption01[4] = "R - Restart game";
		StepOption02[4] = "";
		StepOption03[4] = "";
		StepOption04[4] = "";

		StepTitle[10] = "The Itch, or how to get rid of it";
		StepText[10] = "You scratch your arm,  but it only starts to hurt. If there is something under your skin, you " +
			"will need a tool to remove it."  ;
		StepOption01[10] = "W - Okay, I'll find something.";
		StepOption02[10] = "";
		StepOption03[10] = "";
		StepOption04[10] = "";

		StepTitle[11] = "Finding a tool : Your room";
		StepText[11] = "Where to turn to now?";
		StepOption01[11] = "W - Go straight ahead to the kitchen.";
		StepOption02[11] = "A - Go left to the cellar";
		StepOption03[11] = "D - Go right to your desk";
		StepOption04[11] = "";

		StepTitle[12] = "Finding a tool : The kitchen";
		StepText[12] = "There is a drawer with lots of knifes here They look a little too big for what you a trying to do...";
		StepOption01[12] = "W - Use a big knife on your arm";
		StepOption02[12] = "";
		StepOption03[12] = "";
		StepOption04[12] = "S - Return to your room";

		StepTitle[13] = "Finding a tool : The cellar";
		StepText[13] = "Dark, cold place, kinda dirty. What you are looking for is not here.";
		StepOption01[13] = "";
		StepOption02[13] = "";
		StepOption03[13] = "";
		StepOption04[13] = "S - Return to your room";
		
		StepTitle[14] = "Finding a tool : Your desk";
		StepText[14] = "You keep a knife here somewhere that's suitable for the job.";
		StepOption01[14] = "W - Check the drawers";
		StepOption02[14] = "";
		StepOption03[14] = "";
		StepOption04[14] = "S - Turn away from your desk";
		
		StepTitle[15] = "Finding a tool : Wrong one...";
		StepText[15] = "Oh no, the big knife cuts far to deep into your arm. Amongst all the blood coming from your arm, you see... " +
			"Nothing. You see only blood. And then, you faint. And bleed to death.";
		StepOption01[15] = "R - Restart game";
		StepOption02[15] = "";
		StepOption03[15] = "";
		StepOption04[15] = "";

		StepTitle[16] = "Found a tool!";
		StepText[16] = "This knife seems small enough, yet very sharp. You might use it.";
		StepOption01[16] = "";
		StepOption02[16] = "A - Use it right away.";
		StepOption03[16] = "D - Hey, wait a moment!";
		StepOption04[16] = "";

		StepTitle[17] = "Blood...";
		StepText[17] = "Once you cut yourself, you realize that this isn't such a good idea. The blade is very sharp, " +
			"and you cut deeper and deeper. You don't find what you are looking for. And you cut up your arm very badly. It feels like life is dripping away from you...";
		StepOption01[17] = "R - Restart game";
		StepOption02[17] = "";
		StepOption03[17] = "";
		StepOption04[17] = "";

		StepTitle[18] = "Just some more stuff";
		StepText[18] = "Maybe you should get a first aid kit or something like that. You saw one in the cellar...";
		StepOption01[18] = "W - Check the cellar!";
		StepOption02[18] = "";
		StepOption03[18] = "";
		StepOption04[18] = "S - Still cut yourself right away.";

		StepTitle[19] = "A monster in the cellar";
		StepText[19] = "As you stumble through the dark cellar, something grabs you leg. And then your other leg. And then the rest of you... What?";
		StepOption01[19] = "R - Restart game";
		StepOption02[19] = "";
		StepOption03[19] = "";
		StepOption04[19] = "";

		StepTitle[20] = "Gate to another dimension";
		StepText[20] = "A gate to another dimension has just opened behind your cellar door and sweeps you away. Don't you just hate it when that happens?";
		StepOption01[20] = "R - Restart game";
		StepOption02[20] = "";
		StepOption03[20] = "";
		StepOption04[20] = "";

		StepTitle[21] = "The object";
		StepText[21] = "You carefully cut something from your arm, then stop the bleeding and put a bandage on your arm. When you take a " +
			"closer look at what you cut out of yourself, you see... TO BE CONTINUED";
		StepOption01[21] = "R - Restart game";
		StepOption02[21] = "";
		StepOption03[21] = "";
		StepOption04[21] = "";

		DropStep = true;

		Random.seed = (int)Time.time;

		// handle cursor
		Screen.showCursor = false;	
		Screen.lockCursor = true;
	}
	
	// Update is called once per frame
	void Update () {
		if (GameState == 0)
		{
			if (Input.GetKeyDown(KeyCode.A))
			{
				GotoGameState(10);
			}
			
			if (Input.GetKeyDown(KeyCode.D))
			{
				int zuffi = Random.Range (1,5);
				int NextGameState;
				
				NextGameState = 1;
				
				if (zuffi == 2)
				{
					NextGameState = 2;
				}
				if (zuffi == 3)
				{
					NextGameState = 3;
				}
				if (zuffi == 4 && !MyGameConstants.ShownMS)
				{
					NextGameState = 4;
					MyGameConstants.ShownMS = true;
				}

				GotoGameState(NextGameState);
			}
		}

		if (GameState == 10)
		{
			if (Input.GetKeyDown(KeyCode.W))
			{
				GotoGameState(11);
			}
			
		}

		// your room
		if (GameState == 11)
		{
			if (Input.GetKeyDown(KeyCode.W))
			{
				GotoGameState(12);
			}
			
			if (Input.GetKeyDown(KeyCode.A))
			{
				GotoGameState(13);
			}
			
			if (Input.GetKeyDown(KeyCode.D))
			{
				GotoGameState(14);
			}
			
		}

		// kitchen
		if (GameState == 12)
		{
			if (Input.GetKeyDown(KeyCode.W))
			{
				GotoGameState(15);
			}
			
			if (Input.GetKeyDown(KeyCode.S))
			{
				GotoGameState(11);
			}
		}

		// cellar, looking for a tool
		if (GameState == 13)
		{
			if (Input.GetKeyDown(KeyCode.S))
			{
				GotoGameState(11);
			}
		}

		// your desk
		if (GameState == 14)
		{
			if (Input.GetKeyDown(KeyCode.W))
			{
				GotoGameState(16);
			}
			
			if (Input.GetKeyDown(KeyCode.S))
			{
				GotoGameState(11);
			}
		}

		// use knife
		if (GameState == 16)
		{
			if (Input.GetKeyDown(KeyCode.A))
			{
				GotoGameState(17);
			}
			
			if (Input.GetKeyDown(KeyCode.D))
			{
				GotoGameState(18);
			}
		}

		// check cellar?
		if (GameState == 18)
		{
			if (Input.GetKeyDown(KeyCode.W))
			{
				int zuffi = Random.Range (1,6);
				int NextGameState;
				
				NextGameState = 19;
				
				if (zuffi == 2)
				{
					NextGameState = 20;
				}
				if (zuffi == 3 || zuffi == 4 || zuffi == 5)
				{
					NextGameState = 21;
				}

				GotoGameState(NextGameState);
			}
			
			if (Input.GetKeyDown(KeyCode.S))
			{
				GotoGameState(17);
			}
		}

		if (DropStep)
		{
			Vector3 TempPos;		
			Quaternion SpawnRotation;
			
			SpawnRotation = Quaternion.Euler (Random.value * 10f,180f + Random.value * 10f,Random.value);

			TempPos.x = 0.5f  + (Random.value * 1f);
			TempPos.y = 9f;
			TempPos.z = 0.2f + (Random.value * 0.5f);
					
			Instantiate(Steps[GameState], TempPos, SpawnRotation);

			DropStep = false;

			// end of game
			if (    GameState == 1
			    || GameState == 2
			    || GameState == 3
			    || GameState == 4
			    || GameState == 15
			    || GameState == 17
			    || GameState == 19
			    || GameState == 20
			    || GameState == 21
			    )
			{
				audio.volume = 1f;				
				audio.PlayOneShot (TheSound01);					
			}

		}


		if (MyGameConstants.LevelUpAmount <= 0 && Time.time >= NextTimeAction && !HasEnded)
		{
			HasEnded = true;
			MyGameConstants.LevelUp();
		}

	}

	void GotoGameState(int value)
	{
		if (Time.time >= NextTimeAction)
		{
			GameState = value;
			DropStep = true;
			NextTimeAction = Time.time + 1f;
		}
	}

	// --- GUI-Stuff 	
	void OnGUI () {

		string Text;

		Text = " ";

		GuiRect.width = 100;			
		GuiRect.height = 30;
		
		GuiRect.x = 20;
		GuiRect.y = 20;
		
		GUI.Label (GuiRect, StepTitle[GameState], BigCustomGUIStyle);		

		GuiRect.width = 900;			
		GuiRect.height = 600;
		
		GuiRect.x = 80;
		GuiRect.y = 80;
		
		GUI.Label (GuiRect, StepText[GameState], CustomGUIStyle);

		GuiRect.width = 900;			
		GuiRect.height = 600;
		
		GuiRect.x = 80;
		GuiRect.y = Screen.height - 200;
		
		GUI.Label (GuiRect, StepOption01[GameState], CustomGUIStyle);		
		GuiRect.width = 900;			
		GuiRect.height = 600;
		
		GuiRect.x = 80;
		GuiRect.y = Screen.height - 170;
		
		GUI.Label (GuiRect, StepOption02[GameState], CustomGUIStyle);		

		GuiRect.width = 900;			
		GuiRect.height = 600;
		
		GuiRect.x = 80;
		GuiRect.y = Screen.height - 140;
		
		GUI.Label (GuiRect, StepOption03[GameState], CustomGUIStyle);		
		GuiRect.width = 900;			
		GuiRect.height = 600;
		
		GuiRect.x = 80;
		GuiRect.y = Screen.height - 110;
		
		GUI.Label (GuiRect, StepOption04[GameState], CustomGUIStyle);		

	}
}
